import { AccessRights, AccessRightsFilter } from './access';
import { Change, ChangeFilter, Changed, Created } from './change';
import { EntityFilter } from './entity';
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.domain.file.FileInfo <br/>
*/
export interface FileInfo extends Changed, Created {
    accessRights?: AccessRights;
    change?: Change;
    created?: Change;
    fileContent?: number[];
    fileId?: string;
    fileName?: string;
    mime?: string;
    parentId?: string;
    tags?: string[];
    type?: FileType;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.domain.file.FileInfoFilter <br/>
*/
export interface FileInfoFilter extends EntityFilter {
    accessFilter?: AccessRightsFilter;
    change?: ChangeFilter;
    created?: ChangeFilter;
    fileId?: string;
    fileName?: string;
    parentId?: string;
    tag?: string;
    type?: FileType;
}
export declare enum FileType {
    FILE = "FILE",
    DIRECTORY = "DIRECTORY"
}
