/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ConfigAspect() { }
if (false) {
    /**
     * @param {?} locations
     * @param {?} rejectNotFound
     * @return {?}
     */
    ConfigAspect.prototype.initConfigs = function (locations, rejectNotFound) { };
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.getBaseUrl = function (id) { };
    /**
     * @deprecated
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.getConfig = function (id) { };
    /**
     * @deprecated
     * @param {?} url
     * @return {?}
     */
    ConfigAspect.prototype.loadConfig = function (url) { };
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.getValue = function (id) { };
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.formatUrl = function (id) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * copy of chaos-sys-type (ts) <br/>
 * changes should in this file should copied over to chaos-sys libs
 * @author ww
 */
class SysType {
    // @toDo [ww] package chaos-sys + chaos-front for angular
    /**
     * @private
     */
    constructor() {
    }
    /**
     * @param {?} source
     * @return {?}
     */
    static isArray(source) {
        return source instanceof Array;
    }
    /**
     * @template E
     * @param {?} value
     * @return {?}
     */
    static toArray(value) {
        if (!value) {
            return [];
        }
        if (SysType.isArray(value))
            return value;
        return [value];
    }
    /**
     * @param {?} source
     * @return {?}
     */
    static isDate(source) {
        return source instanceof Date;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    static isPrimitive(value) {
        /** @type {?} */
        let type = typeof value;
        return type === 'string' || type === 'number' || type === 'boolean' || SysType.isDate(value);
    }
    // -----------------------------------------------------------------------------------------------------------------
    /**
     * @param {?} destination
     * @param {?} source
     * @param {?=} cloneDest
     * @return {?}
     */
    static objectMix(destination, source, cloneDest = false) {
        /** @type {?} */
        let target;
        /** @type {?} */
        let property;
        if (SysType.isArray(source)) {
            //console.debug("objectMix source array");
            if (cloneDest) {
                source = [destination].concat(source);
                target = {};
            }
            else
                target = destination;
            for (let idx = 0; idx < source.length; idx++) {
                //console.group("objectMix("+idx+")");
                target = SysType.objectMix(target, source[idx]);
                //console.groupEnd()
            }
            return target;
        }
        if (cloneDest) {
            //target = SysType.objectMix({} , destination, false);
            target = SysType.objectClone(destination);
        }
        else {
            target = destination || {};
        }
        //noinspection JSLint
        for (property in source) {
            if (!source.hasOwnProperty(property))
                continue;
            /** @type {?} */
            let src = source[property];
            if (SysType.isDate(src)) {
                target[property] = SysType.objectClone(src) || destination[property];
                continue;
            }
            if (SysType.isPrimitive(src)) {
                //console.debug("%s <= %s || %s", property, JSON.stringify(src || 'no src'),JSON.stringify(destination ? destination[property] : 'no dest')
                //console.debug("%s <= %s || %s", property, JSON.stringify(src || 'no src'), destination ? JSON.stringify(destination[property]) : 'no dest' );
                //noinspection JSUnfilteredForInLoop
                target[property] = src || destination[property];
                continue;
            }
            if (SysType.isArray(src)) {
                //console.group(property+"["+src.length+"]");
                //target = cloneDest ? SysType.objectClone(SysType.toArray(destination)) : SysType.toArray(destination);
                /** @type {?} */
                let tar = SysType.toArray(destination[property]);
                for (let i = 0; i < src.length; i++) {
                    tar[i] = SysType.objectMix(tar[i], src[i], false);
                }
                target[property] = tar;
                //console.groupEnd();
            }
            else {
                //<debug>
                //console.group(property+" (obj)");
                //</debug>
                target[property] = SysType.objectMix(destination[property], src, false);
                //<debug>
                //console.groupEnd();
                //</debug>
            }
        }
        return target;
    }
    /**
     * @param {?} source
     * @return {?}
     */
    static objectClone(source) {
        if (!source) {
            return source;
        }
        if (SysType.isDate(source)) {
            return new Date(((/** @type {?} */ (source))).valueOf());
        }
        if (SysType.isPrimitive(source)) {
            return source;
        }
        /** @type {?} */
        let target;
        if (SysType.isArray(source)) {
            target = [];
            for (let i = 0; i < source.length; i++) {
                target[i] = SysType.objectClone(source[i]);
            }
            return target;
            //return source.slice();
        }
        target = {};
        for (let property in source) {
            if (!source.hasOwnProperty(property))
                continue;
            target[property] = SysType.objectClone(source[property]);
        }
        return target;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const DetailLevel = {
    DEBUG: 0,
    INFO: 1,
    WARN: 2,
    ERROR: 3,
    FATAL: 30,
    MAX: 9999,
};
DetailLevel[DetailLevel.DEBUG] = 'DEBUG';
DetailLevel[DetailLevel.INFO] = 'INFO';
DetailLevel[DetailLevel.WARN] = 'WARN';
DetailLevel[DetailLevel.ERROR] = 'ERROR';
DetailLevel[DetailLevel.FATAL] = 'FATAL';
DetailLevel[DetailLevel.MAX] = 'MAX';
/** @enum {string} */
const ResultCode = {
    OK: "OK",
    IO: "IO",
    VALID: "VALID",
    INVALID: "INVALID",
    DUPLICATE: "DUPLICATE",
    DATA_ACCESS: "DATA_ACCESS",
    NOT_FOUND: "NOT_FOUND",
    UNKNOWN: "UNKNOWN",
    DELETE: "DELETE",
};
/**
 * @record
 */
function ResultDetail() { }
if (false) {
    /** @type {?} */
    ResultDetail.prototype.text;
    /** @type {?} */
    ResultDetail.prototype.code;
    /** @type {?} */
    ResultDetail.prototype.type;
    /** @type {?} */
    ResultDetail.prototype.level;
}
/**
 * @abstract
 */
class AbstractResult {
    /**
     * @protected
     * @param {?=} data
     */
    constructor(data) {
        this.messages = [];
        Object.assign(this, data);
    }
    /*  public constructor(operation: string, fqn: string) {
            this.operation = operation;
            this.fqn = fqn;
            this.stamp = new Date();
        }*/
    /**
     * @return {?}
     */
    hasError() {
        return this.findDetail();
    }
    /**
     * @return {?}
     */
    hasWarn() {
        return this.findDetail(DetailLevel.WARN, DetailLevel.ERROR);
    }
    /**
     * @param {?=} minLevel
     * @param {?=} maxLevel
     * @return {?}
     */
    findDetail(minLevel = DetailLevel.ERROR, maxLevel = DetailLevel.MAX) {
        /** @type {?} */
        var details = this.messages;
        if (details) {
            for (var i = 0; i < details.length; i++) {
                /** @type {?} */
                var msg = details[i];
                //console.log("AbstractResult findDetail [%d,%d] %o ", minLevel, maxLevel, msg);
                if (msg.level >= minLevel && msg.level <= maxLevel)
                    return msg;
            }
        }
        return null;
    }
    /**
     * @return {?}
     */
    findMaxDetail() {
        /** @type {?} */
        var max = null;
        /** @type {?} */
        var details = this.messages;
        if (details != null && details.length) {
            max = details[0];
            for (var idx = 0; idx < details.length; idx++) {
                /** @type {?} */
                let detail = details[idx];
                if (detail.level >= max.level) {
                    max = detail;
                }
            }
        }
        return max;
    }
    /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    error(text, code = null, type = null) {
        /** @type {?} */
        let detail = (/** @type {?} */ ({ text: text, code: code, type: type, level: DetailLevel.ERROR }));
        this.messages.push(detail);
        return detail;
        // return new ResultDetail(text, code, type, DetailLevel.ERROR);
    }
    /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    warn(text, code = null, type = null) {
        /** @type {?} */
        let detail = (/** @type {?} */ ({ text: text, code: code, type: type, level: DetailLevel.WARN }));
        this.messages.push(detail);
        return detail;
    }
    /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    info(text, code = null, type = null) {
        /** @type {?} */
        let detail = (/** @type {?} */ ({ text: text, code: code, type: type, level: DetailLevel.INFO }));
        this.messages.push(detail);
        return detail;
    }
    /**
     * @param {?} text
     * @param {?=} type
     * @return {?}
     */
    ok(text, type) {
        /** @type {?} */
        let detail = (/** @type {?} */ ({ text: text, code: ResultCode.OK, type: type, level: DetailLevel.INFO }));
        this.messages.push(detail);
        return detail;
    }
    /**
     * @param {?} data
     * @return {?}
     */
    static fromData(data) {
        //console.log("Setting", "fromData => ", data);
        // [ww] hack: fallback
        // noinspection TypeScriptValidateTypes
        //return new AbstractResult(data);
        throw new Error("");
    }
}
if (false) {
    /** @type {?} */
    AbstractResult.prototype.operation;
    /** @type {?} */
    AbstractResult.prototype.fqn;
    /** @type {?} */
    AbstractResult.prototype.messages;
    /** @type {?} */
    AbstractResult.prototype.stamp;
}
class EditResult extends AbstractResult {
    /**
     * @param {?=} data
     */
    constructor(data) {
        super(data);
    }
    /*  constructor(key: string, operation: string, fqn: string) {
            super(operation, fqn);
            this.key = key;
        }*/
    /**
     * @param {?} data
     * @return {?}
     */
    static fromData(data) {
        //console.log("Setting", "fromData => ", data);
        return new EditResult(data);
    }
}
if (false) {
    /** @type {?} */
    EditResult.prototype.key;
}
/**
 * @template E
 */
class QueryResult extends AbstractResult {
    /**
     * @param {?=} data
     */
    constructor(data) {
        super(data);
        this.items = [];
        this.items = data.items;
    }
    /**
     * @template E
     * @param {?} data
     * @return {?}
     */
    static fromData(data) {
        return new QueryResult(data);
    }
}
if (false) {
    /** @type {?} */
    QueryResult.prototype.items;
    /** @type {?} */
    QueryResult.prototype.rows;
    /** @type {?} */
    QueryResult.prototype.hasMore;
}
class ErrorResult extends AbstractResult {
    /**
     * @param {?=} data
     */
    constructor(data) {
        super(data);
    }
    /**
     * @param {?} data
     * @return {?}
     */
    static fromData(data) {
        return new ErrorResult(data);
    }
}
if (false) {
    /** @type {?} */
    ErrorResult.prototype.exception;
}
/**
 * elastic search result
 * @record
 * @template E
 */
function SearchResult() { }
if (false) {
    /** @type {?|undefined} */
    SearchResult.prototype.total;
    /** @type {?|undefined} */
    SearchResult.prototype.took;
    /** @type {?|undefined} */
    SearchResult.prototype.timedOut;
    /** @type {?} */
    SearchResult.prototype.rows;
}
/**
 * @record
 */
function ResultFilter() { }
if (false) {
    /** @type {?|undefined} */
    ResultFilter.prototype.operation;
    /** @type {?|undefined} */
    ResultFilter.prototype.status;
    /** @type {?|undefined} */
    ResultFilter.prototype.userId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.access.AccessRights <br/>
 * @record
 */
function AccessRights() { }
if (false) {
    /** @type {?|undefined} */
    AccessRights.prototype.readGroups;
    /** @type {?|undefined} */
    AccessRights.prototype.readUsers;
    /** @type {?|undefined} */
    AccessRights.prototype.writeGroups;
    /** @type {?|undefined} */
    AccessRights.prototype.writeUsers;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.access.AccessRightsFilter <br/>
 * @record
 */
function AccessRightsFilter() { }
if (false) {
    /** @type {?|undefined} */
    AccessRightsFilter.prototype.readGroups;
    /** @type {?|undefined} */
    AccessRightsFilter.prototype.readUsers;
    /** @type {?|undefined} */
    AccessRightsFilter.prototype.writeGroups;
    /** @type {?|undefined} */
    AccessRightsFilter.prototype.writeUsers;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.access.Owner <br/>
 * @record
 */
function Owner() { }
if (false) {
    /** @type {?|undefined} */
    Owner.prototype.groups;
    /** @type {?|undefined} */
    Owner.prototype.user;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.change.Change <br/>
 * @record
 */
function Change() { }
if (false) {
    /** @type {?} */
    Change.prototype.date;
    /**
     * \@example my example change
     * @type {?|undefined}
     */
    Change.prototype.notes;
    /**
     * \@example sample\@yukawa.de
     * @type {?|undefined}
     */
    Change.prototype.user;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.change.ChangeFilter <br/>
 * @record
 */
function ChangeFilter() { }
if (false) {
    /** @type {?|undefined} */
    ChangeFilter.prototype.date;
    /** @type {?|undefined} */
    ChangeFilter.prototype.user;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.change.Changed <br/>
 * @record
 */
function Changed() { }
if (false) {
    /** @type {?|undefined} */
    Changed.prototype.change;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.change.Created <br/>
 * @record
 */
function Created() { }
if (false) {
    /** @type {?|undefined} */
    Created.prototype.created;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.entity.ChainEntity <br/>
 * @record
 */
function ChainEntity() { }
if (false) {
    /** @type {?|undefined} */
    ChainEntity.prototype.key;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.entity.ChainEntityBase <br/>
 * @record
 */
function ChainEntityBase() { }
if (false) {
    /** @type {?|undefined} */
    ChainEntityBase.prototype.change;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.entity.ChainKey <br/>
 * @record
 */
function ChainKey() { }
if (false) {
    /** @type {?|undefined} */
    ChainKey.prototype.entity;
    /** @type {?|undefined} */
    ChainKey.prototype.id;
    /** @type {?|undefined} */
    ChainKey.prototype.module;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.entity.EntityFilter <br/>
 * @record
 */
function EntityFilter() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.event.ChainEntityEvent <br/>
 * @record
 * @template E
 */
function ChainEntityEvent() { }
if (false) {
    /** @type {?|undefined} */
    ChainEntityEvent.prototype.key;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.event.ChainEvent <br/>
 * @record
 * @template P
 */
function ChainEvent() { }
if (false) {
    /** @type {?|undefined} */
    ChainEvent.prototype.module;
    /** @type {?|undefined} */
    ChainEvent.prototype.name;
    /** @type {?|undefined} */
    ChainEvent.prototype.payload;
    /** @type {?|undefined} */
    ChainEvent.prototype.timeStamp;
    /** @type {?|undefined} */
    ChainEvent.prototype.tx;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.event.ChainEventBase <br/>
 * @record
 * @template P
 */
function ChainEventBase() { }
if (false) {
    /** @type {?|undefined} */
    ChainEventBase.prototype.module;
    /** @type {?|undefined} */
    ChainEventBase.prototype.name;
    /** @type {?|undefined} */
    ChainEventBase.prototype.timeStamp;
    /** @type {?|undefined} */
    ChainEventBase.prototype.tx;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.event.ChainEventBean <br/>
 * @record
 * @template P
 */
function ChainEventBean() { }
if (false) {
    /** @type {?|undefined} */
    ChainEventBean.prototype.payload;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.file.FileInfo <br/>
 * @record
 */
function FileInfo() { }
if (false) {
    /** @type {?|undefined} */
    FileInfo.prototype.accessRights;
    /** @type {?|undefined} */
    FileInfo.prototype.change;
    /** @type {?|undefined} */
    FileInfo.prototype.created;
    /** @type {?|undefined} */
    FileInfo.prototype.fileContent;
    /** @type {?|undefined} */
    FileInfo.prototype.fileId;
    /** @type {?|undefined} */
    FileInfo.prototype.fileName;
    /** @type {?|undefined} */
    FileInfo.prototype.mime;
    /** @type {?|undefined} */
    FileInfo.prototype.parentId;
    /** @type {?|undefined} */
    FileInfo.prototype.tags;
    /** @type {?|undefined} */
    FileInfo.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.file.FileInfoFilter <br/>
 * @record
 */
function FileInfoFilter() { }
if (false) {
    /** @type {?|undefined} */
    FileInfoFilter.prototype.accessFilter;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.change;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.created;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.fileId;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.fileName;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.parentId;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.tag;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.type;
}
/** @enum {string} */
const FileType = {
    FILE: "FILE",
    DIRECTORY: "DIRECTORY",
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.filter.BaseFilter <br/>
 * @record
 */
function BaseFilter() { }
/** @enum {string} */
const OrderDir = {
    ASC: "ASC",
    DESC: "DESC",
};
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.filter.Pager <br/>
 * @record
 */
function Pager() { }
if (false) {
    /**
     * \@example 0
     * @type {?|undefined}
     */
    Pager.prototype.firstResult;
    /**
     * \@example 50
     * @type {?|undefined}
     */
    Pager.prototype.pageSize;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.filter.TableFilter <br/>
 * @record
 */
function TableFilter() { }
if (false) {
    /**
     * \@example *
     * @type {?|undefined}
     */
    TableFilter.prototype.keyword;
    /**
     * \@example _id
     * @type {?|undefined}
     */
    TableFilter.prototype.orderBy;
    /**
     * 	values: ASC,DESC<br/>
     * \@example DESC
     * @type {?|undefined}
     */
    TableFilter.prototype.orderDir;
    /** @type {?|undefined} */
    TableFilter.prototype.pager;
    /**
     * \@example 300000
     * @type {?|undefined}
     */
    TableFilter.prototype.timeout;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.info.Enabled <br/>
 * @record
 */
function Enabled() { }
if (false) {
    /** @type {?|undefined} */
    Enabled.prototype.enabled;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.info.HostStoreInfo <br/>
 * @record
 */
function HostStoreInfo() { }
if (false) {
    /** @type {?|undefined} */
    HostStoreInfo.prototype.ctxp;
    /** @type {?|undefined} */
    HostStoreInfo.prototype.host;
    /** @type {?|undefined} */
    HostStoreInfo.prototype.port;
    /** @type {?|undefined} */
    HostStoreInfo.prototype.storeNames;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.info.Info <br/>
 * @record
 */
function Info() { }
if (false) {
    /** @type {?|undefined} */
    Info.prototype.desc;
    /** @type {?|undefined} */
    Info.prototype.id;
    /** @type {?|undefined} */
    Info.prototype.name;
    /** @type {?|undefined} */
    Info.prototype.shortName;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.info.InfoProvider <br/>
 * @record
 */
function InfoProvider() { }
if (false) {
    /** @type {?|undefined} */
    InfoProvider.prototype.info;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.module.AspectInfo <br/>
 * @record
 */
function AspectInfo() { }
if (false) {
    /** @type {?|undefined} */
    AspectInfo.prototype.requests;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.module.ModuleFilter <br/>
 * @record
 */
function ModuleFilter() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.module.ModuleInfo <br/>
 * @record
 */
function ModuleInfo() { }
if (false) {
    /** @type {?|undefined} */
    ModuleInfo.prototype.aspects;
    /** @type {?|undefined} */
    ModuleInfo.prototype.reg;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.person.Address <br/>
 * @record
 */
function Address() { }
if (false) {
    /** @type {?|undefined} */
    Address.prototype.addressId;
    /** @type {?|undefined} */
    Address.prototype.city;
    /** @type {?|undefined} */
    Address.prototype.geoLocation;
    /** @type {?|undefined} */
    Address.prototype.houseNumber;
    /** @type {?|undefined} */
    Address.prototype.street;
    /**
     * \@example main
     * @type {?|undefined}
     */
    Address.prototype.type;
    /** @type {?|undefined} */
    Address.prototype.zipCode;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.person.AddressFilter <br/>
 * @record
 */
function AddressFilter() { }
if (false) {
    /** @type {?|undefined} */
    AddressFilter.prototype.addressId;
    /** @type {?|undefined} */
    AddressFilter.prototype.city;
    /** @type {?|undefined} */
    AddressFilter.prototype.houseNumber;
    /** @type {?|undefined} */
    AddressFilter.prototype.street;
    /** @type {?|undefined} */
    AddressFilter.prototype.zipCode;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.person.GeoLocation <br/>
 * @record
 */
function GeoLocation() { }
if (false) {
    /** @type {?|undefined} */
    GeoLocation.prototype.altitude;
    /** @type {?|undefined} */
    GeoLocation.prototype.latitude;
    /** @type {?|undefined} */
    GeoLocation.prototype.longitude;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.person.Person <br/>
 * @record
 */
function Person() { }
if (false) {
    /** @type {?|undefined} */
    Person.prototype.addresses;
    /** @type {?|undefined} */
    Person.prototype.change;
    /** @type {?|undefined} */
    Person.prototype.companyName;
    /** @type {?|undefined} */
    Person.prototype.created;
    /** @type {?|undefined} */
    Person.prototype.email;
    /** @type {?|undefined} */
    Person.prototype.firstName;
    /** @type {?|undefined} */
    Person.prototype.lastName;
    /** @type {?|undefined} */
    Person.prototype.mobile;
    /** @type {?|undefined} */
    Person.prototype.phoneNumber;
    /** @type {?|undefined} */
    Person.prototype.role;
    /** @type {?|undefined} */
    Person.prototype.shortName;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.person.PersonFilter <br/>
 * @record
 */
function PersonFilter() { }
if (false) {
    /** @type {?|undefined} */
    PersonFilter.prototype.companyName;
    /** @type {?|undefined} */
    PersonFilter.prototype.email;
    /** @type {?|undefined} */
    PersonFilter.prototype.firstName;
    /** @type {?|undefined} */
    PersonFilter.prototype.lastName;
    /** @type {?|undefined} */
    PersonFilter.prototype.phoneNumber;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.range.BigDecimalRange <br/>
 * @record
 */
function BigDecimalRange() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.range.DataRange <br/>
 * @record
 * @template V
 */
function DataRange() { }
if (false) {
    /** @type {?|undefined} */
    DataRange.prototype.from;
    /** @type {?|undefined} */
    DataRange.prototype.to;
    /** @type {?|undefined} */
    DataRange.prototype.valueFrom;
    /** @type {?|undefined} */
    DataRange.prototype.valueTo;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.range.DateRange <br/>
 * @record
 */
function DateRange() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.range.IntRange <br/>
 * @record
 */
function IntRange() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.range.LocalDateRange <br/>
 * @record
 */
function LocalDateRange() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.domain.range.Range <br/>
 * @record
 * @template V
 */
function Range() { }
if (false) {
    /** @type {?|undefined} */
    Range.prototype.from;
    /** @type {?|undefined} */
    Range.prototype.to;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.base.core.util.TreeNode <br/>
 * @record
 * @template T
 */
function TreeNode() { }
if (false) {
    /** @type {?} */
    TreeNode.prototype.children;
    /** @type {?|undefined} */
    TreeNode.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractResult, DetailLevel, EditResult, ErrorResult, FileType, OrderDir, QueryResult, ResultCode, SysType };
//# sourceMappingURL=yukawa-chain-base-angular-core.js.map
